let _Symbol$iterator;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { AbstractIterator, AbstractLevel } from 'abstract-level';
import { LevelDB } from '@switt/react-native-leveldb';
import ModuleError from 'module-error';
import fs from 'react-native-fs';
export function multiply(a, b) {
  return Promise.resolve(a * b);
}
const db = new LevelDB('data', true, false);
export const SKReactNativeLevelAdapterOptions = {
  maxSyncOperations: 100
};
_Symbol$iterator = Symbol.iterator;
export class SKReactNativeLevelIterator extends AbstractIterator {
  constructor(db, options) {
    super(db, options);

    _defineProperty(this, "it", void 0);

    _defineProperty(this, "valid", true);

    _defineProperty(this, "options", void 0);

    _defineProperty(this, "hasLimit", void 0);

    _defineProperty(this, "isReversed", void 0);

    _defineProperty(this, "readsKeys", void 0);

    _defineProperty(this, "readsValues", void 0);

    _defineProperty(this, "startingBoundIsOpen", false);

    _defineProperty(this, "endingBoundIsOpen", false);

    _defineProperty(this, "stepCount", 0);

    _defineProperty(this, "startingBound", void 0);

    _defineProperty(this, "endingBound", void 0);

    _defineProperty(this, "keyIsBuf", false);

    _defineProperty(this, "valueIsBuf", false);

    _defineProperty(this, "busy", false);

    _defineProperty(this, "startedReading", false);

    const level = this.db._db;
    console.log('iterator options was', options);
    this.it = level.newIterator();
    this.options = options;
    this.hasLimit = options.limit != undefined && options.limit != -1;
    this.isReversed = options.reverse || false;
    this.readsKeys = options.keys != undefined ? options.keys : true;
    this.readsValues = options.values != undefined ? options.values : true;
    this.keyIsBuf = options.keyEncoding == 'buffer';
    this.valueIsBuf = options.valueEncoding == 'buffer';
    let lowerBound;
    let upperBound;
    let lowerBoundIsOpen = true;
    let upperBoundIsOpen = true; // Counter-intuitively, you don't need to check if gt >= gte, or lt <= lte
    // Because according to the test suite... there's a priority!
    // gte has higher priority than gt, and lte has higher priority than lt!
    // so we just check them later that's all

    if (options.gt != undefined) {
      lowerBound = options.gt;
      lowerBoundIsOpen = false;
    }

    if (options.gte != undefined) {
      lowerBound = options.gte;
      lowerBoundIsOpen = true;
    }

    if (options.lt != undefined) {
      upperBound = options.lt;
      upperBoundIsOpen = false;
    }

    if (options.lte != undefined) {
      upperBound = options.lte;
      upperBoundIsOpen = true;
    } // }


    const startingBound = options.reverse ? upperBound : lowerBound;

    if (startingBound != undefined) {
      this.startingBoundIsOpen = this.isReversed ? upperBoundIsOpen : lowerBoundIsOpen;
      this.it.seek(startingBound);
      this.startingBound = startingBound;

      if (this.it.valid()) {
        const comparison = this.it.compareKey(startingBound);

        if (!(this.isReversed ? upperBoundIsOpen : lowerBoundIsOpen) && comparison == 0 || this.isReversed && comparison > 0) {
          this.isReversed ? this.it.prev() : this.it.next();
        }
      } else if (this.isReversed) {
        // We must have seeked past the end.
        this.it.seekLast();
      }
    } else {
      if (this.isReversed) {
        this.it.seekLast();
      } else {
        // Just... assume it's at first?
        this.it.seekToFirst();
      } // this.isReversed ? this.it.seekLast() : this.it.seekToFirst();

    }

    const endingBound = options.reverse ? lowerBound : upperBound;

    if (endingBound != undefined) {
      this.endingBoundIsOpen = this.isReversed ? lowerBoundIsOpen : upperBoundIsOpen;
      this.endingBound = endingBound; // self.endingSliceStorage = ...
    } else {// nothing?
      // self.endingSliceStorage = NULL
    }
  } // [Symbol.asyncIterator]() {
  //   return {
  //     next: async () => {
  //       const got = await this.next();
  //       if (!got) {
  //         return {
  //           done: true
  //         } as IteratorResult<[StOrArr, StOrArr], void>;
  //       }
  //       return {
  //         value: got,
  //         done: false
  //       } as IteratorResult<[StOrArr, StOrArr], void>
  //     },
  //     throw: async (e: any) => {
  //       const ret = this.current();
  //       this.close();
  //       if (ret != undefined) {
  //         return {
  //           done: false,
  //           value: ret
  //         } as IteratorResult<[StOrArr, StOrArr], void>;
  //       }
  //       return {
  //         done: true
  //       } as IteratorResult<[StOrArr, StOrArr], void>
  //     },
  //     return: (v: any) => {
  //       this.close();
  //       return v;
  //     },
  //     [Symbol.asyncIterator]: () => {
  //       return this[Symbol.asyncIterator]();
  //     }
  //   };
  // }


  async *[_Symbol$iterator]() {
    const ret = await this.next();
    if (ret != undefined) yield ret;
    return;
  }

  current() {
    if (this.isEnded()) {
      return undefined;
    }

    let key = this.readsKeys ? this.keyIsBuf ? this.it.keyBuf() : this.it.keyStr() : undefined;
    let val = this.readsValues ? this.valueIsBuf ? this.it.valueBuf() : this.it.valueStr() : undefined;
    return [key, val];
  } // An empty array signifies the natural end of the iterator
  // so simply yielding a non-empty array signifies non-end


  _next(callback) {
    if (this.busy) {
      callback(new ModuleError('Iterator is busy', {
        code: 'LEVEL_ITERATOR_BUSY'
      }));
      return;
    } else if (!this.valid) {
      callback(new ModuleError('Iterator is not open', {
        code: 'LEVEL_ITERATOR_NOT_OPEN'
      }));
      return;
    } // need to set busy to pass compliance


    this.busy = true;

    try {
      let gotKey;
      let gotValue;

      if (this.it.valid()) {
        // If already started reading, then next() should move the iterator
        if (this.startedReading) {
          if (this.options.reverse) {
            this.it.prev();
          } else {
            this.it.next();
          }
        } else {
          // never started reading yet; just use the same pos.
          this.startedReading = true;
        }

        if (this.isEnded()) {
          gotKey = undefined;
          gotValue = undefined;
        } else {
          if (this.readsKeys) {
            gotKey = this.keyIsBuf ? this.it.keyBuf() : this.it.keyStr();
          }

          if (this.readsValues) {
            gotValue = this.valueIsBuf ? this.it.valueBuf() : this.it.valueStr();
          }
        }
      } else {
        gotKey = undefined;
        gotValue = undefined;
      }

      this.db.nextTick(callback, null, gotKey, gotValue);
      this.busy = false;
    } catch (e) {
      this.busy = false;
      this.db.nextTick(callback, e);
    }
  } // TODO: Make this work and be correct and rename it back to _next(...)


  _nextvnot(size, options, callback) {
    if (this.busy) {
      callback(new ModuleError('Iterator is busy', {
        code: 'LEVEL_ITERATOR_BUSY'
      }));
      return;
    } else if (!this.valid) {
      callback(new ModuleError('Iterator is not open', {
        code: 'LEVEL_ITERATOR_NOT_OPEN'
      }));
      return;
    } // need to set busy to pass compliance


    this.busy = true;
    const it = this.it;
    const nextFn = this.options.reverse ? () => it.prev() : () => it.next();

    try {
      const outVal = [];

      if (!this.startedReading) {
        // not started yet; don't advance yet
        this.startedReading = true;
      } else {
        if (this.isEnded()) {
          // early stop if ended already
          this.busy = false;
          this.db.nextTick(callback, null, outVal);
          return;
        } else {
          // advance one time.
          nextFn();
        }
      }

      for (let i = 0; i < size && !this.isEnded(); i++, nextFn()) {
        let key = this.keyIsBuf ? it.keyBuf() : it.keyStr();
        let value = this.valueIsBuf ? it.valueBuf() : it.valueStr();
        outVal.push([key, value]);
      }

      this.busy = false;
      this.db.nextTick(callback, null, outVal);
    } catch (e) {
      this.busy = false;
      this.db.nextTick(callback, e);
    }
  }

  _seek(target, options) {
    if (!this.valid) {
      return;
    } // Reference : https://github.com/andymatuschak/react-native-leveldown/blob/e7d14cfdf81558d15ecec76e956269081d12a40b/ios/RNLeveldown.mm#L388


    this.it.seek(target);

    if (this.isReversed) {
      if (!this.it.valid()) {
        // We must have seeked past the end.
        this.it.seekLast();
      } // TODO: Change this back once package is patched
      else if (this.it.compareKey(target) > 0) {
        // We seeked past the target; step back.
        if (this.isReversed) {
          this.it.prev();
        } else {
          this.it.next();
        }
      }
    }

    this.startedReading = false;
  }

  _close(callback) {
    this.valid = false;
    this.it.close();

    this.db._openIterators.delete(this);

    this.db.nextTick(callback);
  } // ..


  isEnded() {
    // following https://github.com/andymatuschak/react-native-leveldown/blob/e7d14cfdf81558d15ecec76e956269081d12a40b/ios/RNLeveldown.mm#L162
    if (!this.it.valid()) {
      return true;
    }

    if (this.hasLimit && this.stepCount >= this.limit) {
      return true;
    }

    if (this.endingBound != undefined) {
      const comparison = this.it.compareKey(this.endingBound);

      if (comparison < 0 && this.isReversed || comparison > 0 && !this.isReversed || comparison == 0 && !this.endingBoundIsOpen) {
        return true;
      }
    }

    if (this.startingBound != undefined) {
      const comparison = this.it.compareKey(this.startingBound);

      if (comparison > 0 && this.isReversed || comparison < 0 && !this.isReversed || comparison == 0 && !this.startingBoundIsOpen) {
        return true;
      }
    }

    return false;
  } // [Symbol.asyncIterator]() {
  //   console.log('my asyncgen');
  //   const b: AsyncGenerator<[StOrArr, StOrArr], void, unknown> = {
  //     next: async () => {
  //       const nextRes = await this.next();
  //       const res: IteratorResult<[StOrArr, StOrArr], void> = (nextRes != undefined) ? { done: false, value: nextRes! } : { done: true, value: undefined };
  //       return res;
  //     },
  //     return: async () => {
  //       const currentRes = this.current() as [StOrArr, StOrArr];
  //       const ret: IteratorResult<[StOrArr, StOrArr], void> = (currentRes != undefined) ? { done: false, value: currentRes! } : { done: true, value: undefined };
  //       return ret;
  //     },
  //     throw: async (e) => {
  //       const currentRes = this.current() as [StOrArr, StOrArr];
  //       this.close();
  //       const ret: IteratorResult<[StOrArr, StOrArr], void> = (currentRes != undefined) ? { done: false, value: currentRes! } : { done: true, value: undefined };
  //       return ret;
  //     },
  //     [Symbol.asyncIterator]: this[Symbol.asyncIterator],
  //   };
  //   return b;
  // }
  // async *[Symbol.iterator]() {
  //   try {
  //     let item
  //     while ((item = (await this.next())) !== undefined) {
  //       yield item;
  //     }
  //   } finally {
  //     if (!this.isEnded()) await this.close();
  //   }
  //   // const b: AsyncGenerator<[StOrArr, StOrArr], void, unknown> = {
  //   //   next: async () => {
  //   //     const nextRes = await this.next();
  //   //     const res: IteratorResult<[StOrArr, StOrArr], void> = (nextRes != undefined) ? { done: false, value: nextRes! } : { done: true, value: undefined };
  //   //     return res;
  //   //   },
  //   //   return: async () => {
  //   //     const currentRes = this.current() as [StOrArr, StOrArr];
  //   //     const ret: IteratorResult<[StOrArr, StOrArr], void> = (currentRes != undefined) ? { done: false, value: currentRes! } : { done: true, value: undefined };
  //   //     return ret;
  //   //   },
  //   //   throw: async (e) => {
  //   //     const currentRes = this.current() as [StOrArr, StOrArr];
  //   //     this.close();
  //   //     const ret: IteratorResult<[StOrArr, StOrArr], void> = (currentRes != undefined) ? { done: false, value: currentRes! } : { done: true, value: undefined };
  //   //     return ret;
  //   //   },
  //   //   [Symbol.asyncIterator]: this[Symbol.asyncIterator]
  //   // };
  //   // return b;
  // }


}
export class SKReactNativeLevel extends AbstractLevel {
  constructor(location, options) {
    super({
      encodings: {
        utf8: true
      },
      seek: true,
      streams: false,
      createIfMissing: true,
      errorIfExists: true,
      permanence: true,
      snapshots: false
    }, options);

    _defineProperty(this, "_db", void 0);

    _defineProperty(this, "location", void 0);

    _defineProperty(this, "nextTick", function (callback) {
      for (var _len = arguments.length, params = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        params[_key - 1] = arguments[_key];
      }

      if (!params.length) {
        setImmediate(callback);
      } else {
        setImmediate(() => {
          callback(...params);
        });
      }
    });

    _defineProperty(this, "_openIterators", new Set());

    this.location = location;
  }

  async _open(options, callback) {
    console.log('called with options', options);
    const {
      createIfMissing = true,
      errorIfExists = false
    } = options;

    try {
      if (errorIfExists && (await fs.exists(fs.DocumentDirectoryPath + `/` + this.location))) {
        throw {
          message: 'File already exists'
        };
      }

      this._db = new LevelDB(this.location, createIfMissing, errorIfExists);
      this.nextTick(callback, null);
    } catch (e) {
      const msg = e.message;

      if (msg.includes('does not exist')) {
        const err = new ModuleError(msg, {
          code: 'LEVEL_DATABASE_NOT_OPEN'
        });
        console.log('msg has does not exist');
        this.nextTick(callback, err);
      } else if (msg.includes('exists')) {
        const err = new ModuleError(msg, {
          code: 'LEVEL_DATABASE_NOT_OPEN'
        });
        console.log('msg has already exists');
        this.nextTick(callback, err); // this.nextTick(callback, e);
      } else {
        console.log('open error', 'type', typeof e, e.code, e.message);
        throw e;
      }
    }
  }

  _close(callback) {
    try {
      if (this._openIterators.size) {
        for (const it of this._openIterators) {
          it.valid = false;
          it.it.close();
        }
      }

      if (!this._db.closed) {
        this._db.close();
      }

      this.nextTick(callback, null);
    } catch (e) {
      this.nextTick(callback, e);
    }
  }

  _get(key, options, callback) {
    let res; // For abstract-level, the valueEncoding is how we check (read https://github.com/Level/abstract-level/blob/main/UPGRADING.md#100)

    if (options.valueEncoding == 'buffer') {
      res = this._db.getBuf(key);
    } else {
      res = this._db.getStr(key);
    }

    if (res == null) {
      this.nextTick(callback, new ModuleError(`Key ${key} was not found`, {
        code: 'LEVEL_NOT_FOUND'
      }));
    } else {
      this.nextTick(callback, null, res);
    }
  }

  _getMany(keys, options, callback) {
    try {
      if (options.valueEncoding == 'buffer') {
        const values = keys.map(k => {
          const res = this._db.getBuf(k);

          if (res == null) {
            return undefined;
          }

          return res;
        });
        this.nextTick(callback, null, values);
      } else {
        const values = keys.map(k => {
          const res = this._db.getStr(k);

          if (res == null) {
            return undefined;
          }

          return res;
        });
        this.nextTick(callback, null, values);
      }
    } catch (e) {
      this.nextTick(callback, e);
    }
  }

  _put(key, value, options, callback) {
    try {
      this._db.put(key, value);

      this.nextTick(callback, null);
    } catch (e) {
      this.nextTick(callback, e);
    }
  }

  _del(key, options, callback) {
    try {
      this._db.delete(key);

      this.nextTick(callback, null);
    } catch (e) {
      this.nextTick(callback, e);
    }
  }

  _batch(operations, options, callback) {
    // TODO: Maybe see if we can add batch to actual react-native-leveldb?
    // Or just doing this is enough...
    try {
      for (const op of operations) {
        if (op.type == 'put') {
          console.log('put in', op.key, op.value);

          this._db.put(op.key, op.value);

          op.sublevel;
        } else {
          this._db.delete(op.key);
        } // TODO: What to do with sublevels?
        // op.sublevel?.batch();

      }

      this.nextTick(callback, null);
    } catch (e) {
      this.nextTick(callback, e);
    }
  }

  _iterator(options) {
    const it = new SKReactNativeLevelIterator(this, options);

    this._openIterators.add(it);

    return it;
  } // Hopefully can do this better later with native implementaion?


  async _clear(options, callback) {
    // Since the native code has no clear() we just use our own iterator to get stuff then..
    const it = this.iterator({ ...options,
      values: false
    }); //new SKReactNativeLevelIterator(this, { ...options, values: false });

    try {
      const keys = [];

      while (true) {
        const kv = await it.next();

        if (!kv) {
          break;
        }

        keys.push(kv[0]);
      }

      for (const k of keys) {
        this._db.delete(k);
      }

      this.nextTick(callback, null);
    } catch (e) {
      this.nextTick(callback, e);
    }

    it.close(); // for (const a of this.iterator() as any as SKReactNativeLevelIterator) {
    // }
  }

}
let encoder = new global.TextEncoder();
export function toArraybuf(str) {
  if (str instanceof ArrayBuffer) {
    return str;
  }

  var uint8Arr = encoder.encode(str);
  return uint8Arr.buffer;
}
/**
 * Retrns true if a is greater than b
 * @param a 
 * @param b 
 * @returns 
 */

export function arraybufGt(a, b) {
  var keyA = new Uint8Array(a);
  var keyB = new Uint8Array(b);

  for (var i = 0; i < keyA.byteLength && i < keyB.byteLength; ++i) {
    if (keyA[i] > keyB[i]) {
      return true;
    }

    if (keyA[i] < keyB[i]) {
      return false;
    }
  }

  return keyA.byteLength > keyB.byteLength;
}
/**
 * Retrns true if a is less than b
 * @param a 
 * @param b 
 * @returns 
 */

export function arraybufLt(a, b) {
  var keyA = new Uint8Array(a);
  var keyB = new Uint8Array(b);

  for (var i = 0; i < keyA.byteLength && i < keyB.byteLength; ++i) {
    if (keyA[i] < keyB[i]) {
      return true;
    }

    if (keyA[i] > keyB[i]) {
      return false;
    }
  }

  return keyA.byteLength < keyB.byteLength;
}
export function arraybufCompare(a, b) {
  const keyA = new Uint8Array(a);
  const keyB = new Uint8Array(b);

  for (let i = 0; i < keyA.byteLength && i < keyB.byteLength; ++i) {
    if (keyA[i] > keyB[i]) {
      return 1;
    } else if (keyA[i] < keyB[i]) {
      return -1;
    } else {// continue;
    }
  } // Handle if every starting byte really was same


  if (keyA.byteLength == keyB.byteLength) {
    return 0;
  } else if (keyA.byteLength > keyB.byteLength) {
    return 1;
  } else {
    return -1;
  }
}
//# sourceMappingURL=level.js.map