import { AbstractBatchOperation, AbstractBatchOptions, AbstractClearOptions, AbstractDatabaseOptions, AbstractDelOptions, AbstractGetManyOptions, AbstractGetOptions, AbstractIterator, AbstractIteratorOptions, AbstractLevel, AbstractOpenOptions, AbstractPutOptions, AbstractSeekOptions, NodeCallback } from 'abstract-level';
import { LevelDB, LevelDBIterator } from '@switt/react-native-leveldb';
import type { NextCallback } from 'abstract-level/types/abstract-iterator';
export declare function multiply(a: number, b: number): Promise<number>;
export declare const SKReactNativeLevelAdapterOptions: {
    maxSyncOperations: number;
};
declare type StOrArr = string | ArrayBuffer;
export declare class SKReactNativeLevelIterator extends AbstractIterator<SKReactNativeLevel, StOrArr, StOrArr> {
    it: LevelDBIterator;
    valid: boolean;
    options: AbstractIteratorOptions<StOrArr, StOrArr>;
    hasLimit: boolean;
    isReversed: boolean;
    readsKeys: boolean;
    readsValues: boolean;
    startingBoundIsOpen: boolean;
    endingBoundIsOpen: boolean;
    stepCount: number;
    startingBound?: StOrArr;
    endingBound?: StOrArr;
    keyIsBuf: boolean;
    valueIsBuf: boolean;
    busy: boolean;
    startedReading: boolean;
    constructor(db: any, options: AbstractIteratorOptions<StOrArr, StOrArr>);
    [Symbol.iterator](): AsyncGenerator<[StOrArr, StOrArr], void, unknown>;
    current(): [StOrArr | undefined, StOrArr | undefined] | undefined;
    protected _next(callback: NextCallback<StOrArr, StOrArr>): void;
    protected _nextvnot(size: number, options: {}, callback: NodeCallback<[[StOrArr, StOrArr]]>): void;
    protected _seek(target: StOrArr, options: AbstractSeekOptions<StOrArr>): void;
    protected _close(callback: NodeCallback<void>): void;
    protected isEnded(): boolean;
}
export declare class SKReactNativeLevel extends AbstractLevel<string, string, string> {
    _db?: LevelDB;
    location: string;
    nextTick: (callback: (...args: any[]) => void, ...params: any[]) => void;
    _openIterators: Set<SKReactNativeLevelIterator>;
    constructor(location: string, options?: AbstractDatabaseOptions<string, string> | undefined);
    protected _open(options: AbstractOpenOptions, callback: NodeCallback<void>): Promise<void>;
    protected _close(callback: NodeCallback<void>): void;
    protected _get(key: StOrArr, options: AbstractGetOptions<StOrArr, StOrArr>, callback: NodeCallback<StOrArr>): void;
    protected _getMany(keys: (StOrArr)[], options: AbstractGetManyOptions<string, StOrArr>, callback: NodeCallback<(StOrArr)[]>): void;
    protected _put(key: StOrArr, value: StOrArr, options: AbstractPutOptions<StOrArr, StOrArr>, callback: NodeCallback<void>): void;
    protected _del(key: StOrArr, options: AbstractDelOptions<StOrArr>, callback: NodeCallback<void>): void;
    protected _batch(operations: Array<AbstractBatchOperation<any, StOrArr, StOrArr>>, options: AbstractBatchOptions<StOrArr, StOrArr>, callback: NodeCallback<void>): void;
    protected _iterator(options: AbstractIteratorOptions<StOrArr, StOrArr>): SKReactNativeLevelIterator;
    protected _clear(options: AbstractClearOptions<StOrArr>, callback: NodeCallback<void>): Promise<void>;
}
export declare function toArraybuf(str: string | ArrayBuffer): ArrayBuffer;
/**
 * Retrns true if a is greater than b
 * @param a
 * @param b
 * @returns
 */
export declare function arraybufGt(a: ArrayBuffer, b: ArrayBuffer): boolean;
/**
 * Retrns true if a is less than b
 * @param a
 * @param b
 * @returns
 */
export declare function arraybufLt(a: ArrayBuffer, b: ArrayBuffer): boolean;
export declare function arraybufCompare(a: ArrayBuffer, b: ArrayBuffer): number;
export {};
