import { LevelDB, LevelDBIterator } from '@switt/react-native-leveldb';
import * as ALD from 'abstract-leveldown';
declare type StOrArr = string | ArrayBuffer;
export declare class SKReactNativeLevelDownIterator extends ALD.AbstractIterator<StOrArr, StOrArr> {
    it: LevelDBIterator;
    valid: boolean;
    options: ALD.AbstractIteratorOptions<StOrArr>;
    hasLimit: boolean;
    isReversed: boolean;
    readsKeys: boolean;
    readsValues: boolean;
    startingBoundIsOpen: boolean;
    endingBoundIsOpen: boolean;
    stepCount: number;
    startingBound?: StOrArr;
    endingBound?: StOrArr;
    keyIsBuf: boolean;
    valueIsBuf: boolean;
    busy: boolean;
    startedReading: boolean;
    constructor(db: ALD.AbstractLevelDOWN, options: ALD.AbstractIteratorOptions<StOrArr>);
    current(): [StOrArr | undefined, StOrArr | undefined] | undefined;
    protected _next(callback: ALD.ErrorKeyValueCallback<StOrArr | undefined, StOrArr | undefined>): void;
    protected _seek(target: StOrArr): void;
    protected _close(callback: ALD.ErrorCallback): void;
    protected isEnded(): boolean;
}
export declare class SKReactNativeLevelDown extends ALD.AbstractLevelDOWN {
    databaseName: string;
    _db?: LevelDB;
    _openIterators: Set<SKReactNativeLevelDownIterator>;
    nextTick: (callback: (...args: any[]) => void, ...params: any[]) => void;
    constructor(databaseName: string);
    protected _open(options: ALD.AbstractOpenOptions, callback: ALD.ErrorCallback): Promise<void>;
    protected _close(callback: ALD.ErrorValueCallback<void>): void;
    protected _get(key: StOrArr, options: {
        asBuffer: boolean;
    }, callback: ALD.ErrorValueCallback<StOrArr>): void;
    protected _getMany(keys: (StOrArr)[], options: ALD.AbstractGetOptions, callback: ALD.ErrorValueCallback<(StOrArr)[]>): void;
    protected _put(key: StOrArr, value: StOrArr, options: ALD.AbstractOptions, callback: ALD.ErrorCallback): void;
    protected _del(key: StOrArr, options: ALD.AbstractOptions, callback: ALD.ErrorCallback): void;
    protected _batch(operations: ReadonlyArray<ALD.AbstractBatch<StOrArr, StOrArr>>, options: ALD.AbstractOptions, callback: ALD.ErrorCallback): void;
    protected _iterator(options: ALD.AbstractIteratorOptions<StOrArr>): SKReactNativeLevelDownIterator;
}
export {};
